#include "config.h"
#include "scaling.h"
#include "util.h"

uint16_t current_to_dac(float amps)
{
	float tmp;
	uint16_t dacc;

	tmp = 536.0 / 1.0 * amps + 32524;
	if (tmp < 0)
		tmp = 0;
	if (tmp > 65535)
		tmp = 65535;
	dacc = (uint16_t)(tmp + 0.5);

	return dacc;
}

/* Convert the DAC output value to an effective current in the measuring loop */
float dac_to_current(uint16_t dacv)
{
	float amps;
	amps = ((float)dacv - 32524.0) * 1.0 / 536.0;
 	return amps;
}

float adc12_to_current(int16_t picv)
{
	float amps;

	if (picv < 0)
		picv = 0;
	if (picv > 2047)
		picv = 2047;
	
	amps = (picv - 1024.0) / 404.0;
	return amps;
}

float dac_current_min;
float dac_current_max;

void scaling_init(void)
{
	dac_current_min = dac_to_current(0x0000);
	dac_current_max = dac_to_current(0xffff);
}
