#include "config.h"
#include "adc.h"
#include "adcext.h"
#include "dac.h"
#include "uart.h"
#include "timer.h"
#include "util.h"
#include "led.h"
#include "mode.h"
#include "zoom.h"

void degauss(void)
{
	return;
#if 0
	dac_write(65535); /* max */
	msleep(25);
	dac_write(0);     /* min */
	msleep(25);
	dac_write(32768); /* middle */
	msleep(25);
#endif
}

int main(void)
{
	int jumper;

	config_init();
	led_init();
	led_on();	

	/* debug output */
	TRISAbits.TRISA9 = 0;

	scaling_init();
	adcext_init();
	dac_init();
	dac_write(32768);
	adc_init();

	/* Detect jumper from B8 to GND */
	TRISBbits.TRISB8 = 0;
	LATBbits.LATB8 = 1;
	nop(); nop(); nop();
	jumper = (PORTBbits.RB8 == 0);
	TRISBbits.TRISB8 = 1;

	/* If jumper present, use MODE_1 */
	if (jumper)
		run_debug();
	else
		run_normal();

	for (;;)
		continue;
}
